#ifdef _MSC_VER
#pragma warning(push)
#pragma warning(disable : 4121)
#endif // _MSC_VER

#include <windows.h>
#include <initguid.h>
#include <plugin.hpp>
#include <PluginSettings.hpp>
#include <DlgBuilder.hpp>

#include "Desktop.hpp"
#include "Desktoplng.hpp"
#include "guid.hpp"
#include "version.hpp"

#ifdef _MSC_VER
#pragma warning(pop)
#endif

#include "main.cpp"
#include "mix.cpp"

#if defined(__GNUC__)
#ifdef __cplusplus
extern "C"
{
#endif
	BOOL WINAPI DllMainCRTStartup(HANDLE hDll,DWORD dwReason,LPVOID lpReserved);
#ifdef __cplusplus
};
#endif

BOOL WINAPI DllMainCRTStartup(HANDLE hDll,DWORD dwReason,LPVOID lpReserved)
{
	(void) hDll;
	(void) dwReason;
	(void) lpReserved;
	return TRUE;
}
#endif


struct Options Opt;

struct PluginStartupInfo Info;
struct FarStandardFunctions FSF;

const wchar_t *StrAddToDisksMenu=L"AddToDisksMenu";
const wchar_t *StrAddToPluginsMenu=L"AddToPluginsMenu";
const wchar_t *StrDefaultFolder=L"DefaultFolder";

void WINAPI GetGlobalInfoW(struct GlobalInfo *Info)
{
	Info->StructSize=sizeof(GlobalInfo);
	Info->MinFarVersion=FARMANAGERVERSION;
	Info->Version=PLUGIN_VERSION;
	Info->Guid=MainGuid;
	Info->Title=PLUGIN_NAME;
	Info->Description=PLUGIN_DESC;
	Info->Author=PLUGIN_AUTHOR;
}

void WINAPI SetStartupInfoW(const struct PluginStartupInfo *Info)
{
	::Info=*Info;
	::FSF=*Info->FSF;
	::Info.FSF=&::FSF;
	PluginSettings settings(MainGuid, ::Info.SettingsControl);
	Opt.AddToDisksMenu = settings.Get(0,StrAddToDisksMenu,1);
	Opt.AddToPluginsMenu = settings.Get(0,StrAddToPluginsMenu,1);
	settings.Get(0,StrDefaultFolder,Opt.DefaultFolder,ARRAYSIZE(Opt.DefaultFolder),getDesktop());
}

intptr_t WINAPI ConfigureW(const ConfigureInfo* CInfo)
{
	return Config(CInfo);
}

void WINAPI GetPluginInfoW(struct PluginInfo *Info)
{
	Info->StructSize=sizeof(*Info);
	Info->Flags=0;

	if (Opt.AddToDisksMenu)
	{
		static const wchar_t *DiskMenuStrings[1];
		DiskMenuStrings[0]=GetMsg(MDiskMenuString);
		Info->DiskMenu.Guids=&MenuGuid;
		Info->DiskMenu.Strings=DiskMenuStrings;
		Info->DiskMenu.Count=ARRAYSIZE(DiskMenuStrings);
	}

	if (Opt.AddToPluginsMenu)
	{
		static const wchar_t *PluginMenuStrings[1];
		PluginMenuStrings[0]=GetMsg(MPluginsMenuString);
		Info->PluginMenu.Guids=&MenuGuid;
		Info->PluginMenu.Strings=PluginMenuStrings;
		Info->PluginMenu.Count=ARRAYSIZE(PluginMenuStrings);
	}

	static const wchar_t *PluginCfgStrings[1];
	PluginCfgStrings[0]=GetMsg(MPluginsCfgMenuString);
	Info->PluginConfig.Guids=&MenuGuid;
	Info->PluginConfig.Strings=PluginCfgStrings;
	Info->PluginConfig.Count=ARRAYSIZE(PluginCfgStrings);
}
